//============================================================================
// Basic material editor created for lite-c programming contest
//
// Author: Gordon Tackett
// Date  : 9-15-07
//
//============================================================================

//============================================================================
// Include files

#include <acknex.h>
#include <default.c>
#include <windows.h>

//============================================================================
// Mouse pointer and panel elements

BMAP* PTR_bmap = "PTR.PCX";
BMAP* POINTER_Red_bmap = "POINTERR.TGA";
BMAP* POINTER_Blue_bmap = "POINTERB.TGA";
BMAP* POINTER_Green_bmap = "POINTERG.TGA";
BMAP* slider_bar = "slider_tga.tga";

//============================================================================
// global entity for model

ENTITY* EditEntity = NULL;

//============================================================================
// because the sliders do not like negative numbers use this for the slider
// and once per frame set the material value with a -100 offset
var MyAlbedo = 150;

//============================================================================
// this is to block some double entry into the button code 
var ClickBlock = 0;


//============================================================================
// prototypes for all functions
void Btn1();
void Btn2();
void Btn3();
void Btn4();
void Btn5();
void MouseLeft();
void MouseRight();
void DoFileMenu(int SaveLoad);
void main();

//============================================================================
// the main material structure used to store and ajust the material settings
MATERIAL* NewMaterial = 
{
  	ambient_blue = 0;
  	ambient_green = 0;
  	ambient_red = 0;
  	
  	emissive_blue = 0;
  	emissive_green = 0;
  	emissive_red = 0;
  	
  	diffuse_blue = 0;
	diffuse_green = 0;
	diffuse_red = 0;
	
	specular_blue = 0;
	specular_green = 0;
	specular_red = 0;

	power  = 0;
	alpha = 100;
	albedo = 50;
}

//============================================================================
// The editor panel
PANEL* panel_editor = {
	bmap = "panel1.pcx";
	pos_x = 10;
	pos_y = 10;
	layer = 10;

	digits ( 10, 25,"Ambient","Arial#12b", 1, NULL);

	hslider( 10, 40,266,POINTER_Red_bmap,0,255,NewMaterial.ambient_red);
	window ( 10, 50,256,5,slider_bar,0,0);
	digits (280, 50,"%3.0f","Arial#12b",1,NewMaterial.ambient_red);
	
	hslider( 10, 60,266,POINTER_Green_bmap,0,255,NewMaterial.ambient_green);
	window ( 10, 70,256,5,slider_bar,0,0);
	digits (280, 70,"%3.0f","Arial#12b",1,NewMaterial.ambient_green);

	hslider( 10, 80,266,POINTER_Blue_bmap,0,255,NewMaterial.ambient_blue);
	window ( 10, 90,256,5,slider_bar,0,0);
	digits (280, 90,"%3.0f","Arial#12b",1,NewMaterial.ambient_blue);

	digits ( 10,105,"Emissive","Arial#12b", 1, NULL);

	hslider( 10,120,266,POINTER_Red_bmap,0,255,NewMaterial.emissive_red);
	window ( 10,130,256,5,slider_bar,0,0);
	digits (280,130,"%3.0f","Arial#12b",1,NewMaterial.emissive_red);

	hslider( 10,140,266,POINTER_Green_bmap,0,255,NewMaterial.emissive_green);
	window ( 10,150,256,5,slider_bar,0,0);
	digits (280,150,"%3.0f","Arial#12b",1,NewMaterial.emissive_green);

 	hslider( 10,160,266,POINTER_Blue_bmap,0,255,NewMaterial.emissive_blue);
	window ( 10,170,256,5,slider_bar,0,0);
	digits (280,170,"%3.0f","Arial#12b",1,NewMaterial.emissive_blue);

	digits ( 10,185,"Diffuse","Arial#12b", 1, NULL);

	hslider( 10,200,266,POINTER_Red_bmap,0,255,NewMaterial.diffuse_red);
	window ( 10,210,256,5,slider_bar,0,0);
	digits (280,210,"%3.0f","Arial#12b",1,NewMaterial.diffuse_red);

	hslider( 10,220,266,POINTER_Green_bmap,0,255,NewMaterial.diffuse_green);
	window ( 10,230,256,5,slider_bar,0,0);
	digits (280,230,"%3.0f","Arial#12b",1,NewMaterial.diffuse_green);

	hslider( 10,240,266,POINTER_Blue_bmap,0,255,NewMaterial.diffuse_blue);
	window ( 10,250,256,5,slider_bar,0,0);
	digits (280,250,"%3.0f","Arial#12b",1,NewMaterial.diffuse_blue);

	digits ( 10,265,"Specular","Arial#12b", 1, NULL);

	hslider( 10,280,266,POINTER_Red_bmap,0,255,NewMaterial.specular_red);
	window ( 10,290,256,5,slider_bar,0,0);
	digits (280,290,"%3.0f","Arial#12b",1,NewMaterial.specular_red);

	hslider( 10,300,266,POINTER_Green_bmap,0,255,NewMaterial.specular_green);
	window ( 10,310,256,5,slider_bar,0,0);
	digits (280,310,"%3.0f","Arial#12b",1,NewMaterial.specular_green);

	hslider( 10,320,266,POINTER_Blue_bmap,0,255,NewMaterial.specular_blue);
	window ( 10,330,256,5,slider_bar,0,0);
	digits (280,330,"%3.0f","Arial#12b",1,NewMaterial.specular_blue);

	digits ( 10,345,"Power","Arial#12b", 1, NULL);

	hslider( 10,360,266,POINTER_Red_bmap,0,10,NewMaterial.power);
	window ( 10,370,256,5,slider_bar,0,0);
	digits (280,370,"%3.0f","Arial#12b",1,NewMaterial.power);
	
	digits ( 10,385,"Alpha","Arial#12b", 1, NULL);

	hslider( 10,400,266,POINTER_Red_bmap,0,100,NewMaterial.alpha);
	window ( 10,410,256,5,slider_bar,0,0);
	digits (280,410,"%3.0f","Arial#12b",1,NewMaterial.alpha);

	digits ( 10,425,"Albedo","Arial#12b", 1, NULL);

	hslider( 10,440,266,POINTER_Red_bmap,0,300,MyAlbedo);
	window ( 10,450,256,5,slider_bar,0,0);
	digits (280,450,"%3.0f","Arial#12b",1,NewMaterial.sun_albedo);
	
	button( 10,465,"btn1dn.pcx","btn1up.pcx","btn1up.pcx",Btn1,NULL,NULL);
	button( 60,465,"btn2dn.pcx","btn2up.pcx","btn2up.pcx",Btn2,NULL,NULL);
	button(110,465,"btn3dn.pcx","btn3up.pcx","btn3up.pcx",Btn3,NULL,NULL);
	button(160,465,"btn4dn.pcx","btn4up.pcx","btn4up.pcx",Btn4,NULL,NULL);
	button(210,465,"btn5dn.pcx","btn5up.pcx","btn5up.pcx",Btn5,NULL,NULL);

	flags = VISIBLE | OVERLAY;
}

PANEL* panel_editor_cover = {
	bmap = "panel2.pcx";
	pos_x = 10;
	pos_y = 10;
	layer = 11;
	flags = TRANSLUCENT;
}

//============================================================================
// this is the left mouse button code that is activated for all areas except
// the buttons on the panel. If not in the panel area then it will rotate the
// model. If it is in the top of the panel then it will drag the panel.
// otherwise it do nothing.
void MouseLeft()
{
	var x;
	var y;
	
	if (((mouse_cursor.x > panel_editor.pos_x) && (mouse_cursor.x < (panel_editor.pos_x + panel_editor.size_x)))
	&& ((mouse_cursor.y > panel_editor.pos_y) && (mouse_cursor.y < (panel_editor.pos_y + panel_editor.size_y))))
	{
		//window drag
		if (mouse_cursor.y < (panel_editor.pos_y + 25))
		{
			x = mouse_cursor.x - panel_editor.pos_x;
			y = mouse_cursor.y - panel_editor.pos_y;
			while (mouse_left)
			{
				if (((mouse_cursor.x - x) > 0) && (((mouse_cursor.x - x) + panel_editor.size_x) < screen_size.x))
				{
					panel_editor.pos_x = mouse_cursor.x - x;
				}
				if (((mouse_cursor.y - y) > 0) && (((mouse_cursor.y - y) + panel_editor.size_y) < screen_size.y))
				{
					panel_editor.pos_y = mouse_cursor.y - y;
				}
				panel_editor_cover.pos_x = panel_editor.pos_x;
				panel_editor_cover.pos_y = panel_editor.pos_y; 
				wait(1);
			}
		}
	}
	else
	{
		x = mouse_cursor.x;
		y = mouse_cursor.y;
		panel_editor_cover.flags |= VISIBLE;
		while (mouse_left)
		{
			x = x - mouse_cursor.x;
			y = y - mouse_cursor.y;
 			EditEntity.pan -= x;	// mouse movement changes PAN 
 			EditEntity.tilt -= y;	// mouse movement changes TILT
			x = mouse_cursor.x;
			y = mouse_cursor.y;
			wait(1);	
		}
		panel_editor_cover.flags &= ~VISIBLE;
	}
}

//============================================================================
// this will move the camera in and out to create a zoom effect on the model.
void MouseRight()
{
	var x;
	x = mouse_cursor.y;
	panel_editor_cover.flags |= VISIBLE;
	while(mouse_right)
	{
		x = x - mouse_cursor.y;
		camera.x = camera.x + x;
		if (camera.x > EditEntity.min_x - 15)
		{
			camera.x = EditEntity.min_x - 15;
		}
		x = mouse_cursor.y;
		wait(1);
	}
	panel_editor_cover.flags &= ~VISIBLE;
}


//============================================================================
// this is the main worker function of the program. This function will
// 0 - load a model
// 1 - save the settings to a file
// 2 - load settings from a file
// 3 - write the code for the material to a file
void DoFileMenu(int SaveLoad)
{
	OPENFILENAME OpenFileStruct;
	char szFileName[156];
	var fileHandle;
	STRING* strOutput;
	
	mouse_mode = 0;
	wait(2);				//detach so that it will run as a separate thread
	switch (SaveLoad)
	{
		case 0:
			memset((void*)&OpenFileStruct,0,sizeof(OPENFILENAME));
			szFileName[0] = '\0';	
			OpenFileStruct.lStructSize = sizeof(OPENFILENAME);	
			OpenFileStruct.hwndOwner = hWnd;	
			OpenFileStruct.hInstance = NULL;	
			OpenFileStruct.lpstrFilter = "Models\0*.mdl\0\0\0";	
			OpenFileStruct.lpstrCustomFilter = NULL;	
			OpenFileStruct.nMaxCustFilter = NULL;	
			OpenFileStruct.nFilterIndex = 1;	
			OpenFileStruct.lpstrFile = szFileName;	
			OpenFileStruct.nMaxFile = 155;	
			OpenFileStruct.lpstrFileTitle = NULL;	
			OpenFileStruct.nMaxFileTitle = 0;	
			OpenFileStruct.lpstrInitialDir = NULL;	
			OpenFileStruct.lpstrTitle = NULL;	
			OpenFileStruct.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;	
			OpenFileStruct.nFileOffset = 0;	
			OpenFileStruct.nFileExtension = 1;	
			OpenFileStruct.lpstrDefExt = "mdl";	
			OpenFileStruct.lCustData = 0;	
			OpenFileStruct.lpfnHook = NULL;	
			OpenFileStruct.lpTemplateName = NULL;	
			GetOpenFileName(&OpenFileStruct);
			wait(1);
			if (EditEntity != NULL)
			{
				ent_remove(EditEntity);
				wait(1);	// must wait one frame before we recreate the enityt.
			}
			if (str_len(szFileName))
			{
				EditEntity = ent_create(szFileName,vector(0,0,0),NULL);
				c_setminmax(EditEntity);
				EditEntity.material = NewMaterial;
			}
			break;
		case 1:
			memset((void*)&OpenFileStruct,0,sizeof(OPENFILENAME));	
			szFileName[0] = '\0';	
			OpenFileStruct.lStructSize = sizeof(OPENFILENAME);	
			OpenFileStruct.hwndOwner = hWnd;	
			OpenFileStruct.hInstance = NULL;	
			OpenFileStruct.lpstrFilter = "Material File\0*.msf\0\0\0";	
			OpenFileStruct.lpstrCustomFilter = NULL;	
			OpenFileStruct.nMaxCustFilter = NULL;	
			OpenFileStruct.nFilterIndex = 1;	
			OpenFileStruct.lpstrFile = szFileName;	
			OpenFileStruct.nMaxFile = 155;	
			OpenFileStruct.lpstrFileTitle = NULL;	
			OpenFileStruct.nMaxFileTitle = 0;	
			OpenFileStruct.lpstrInitialDir = NULL;	
			OpenFileStruct.lpstrTitle = NULL;	
			OpenFileStruct.Flags = OFN_OVERWRITEPROMPT;	
			OpenFileStruct.nFileOffset = 0;	
			OpenFileStruct.nFileExtension = 1;	
			OpenFileStruct.lpstrDefExt = "msf";	
			OpenFileStruct.lCustData = 0;	
			OpenFileStruct.lpfnHook = NULL;	
			OpenFileStruct.lpTemplateName = NULL;	
			GetSaveFileName(&OpenFileStruct);
			if (str_len(szFileName))
			{
				fileHandle = file_open_write(szFileName);
				file_var_write(fileHandle,(int)NewMaterial.ambient_red);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.ambient_green);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.ambient_blue);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.emissive_red);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.emissive_green);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.emissive_blue);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.diffuse_red);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.diffuse_green);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.diffuse_blue);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.specular_red);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.specular_green);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.specular_blue);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.power);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.alpha);
				file_str_write(fileHandle,"\n");
				file_var_write(fileHandle,(int)NewMaterial.sun_albedo);
				file_str_write(fileHandle,"\n");
				file_close(fileHandle);
			}
			break;
		case 2:
			memset((void*)&OpenFileStruct,0,sizeof(OPENFILENAME));	
			szFileName[0] = '\0';	
			OpenFileStruct.lStructSize = sizeof(OPENFILENAME);	
			OpenFileStruct.hwndOwner = hWnd;	
			OpenFileStruct.hInstance = NULL;	
			OpenFileStruct.lpstrFilter = "Material File\0*.msf\0\0\0";	
			OpenFileStruct.lpstrCustomFilter = NULL;	
			OpenFileStruct.nMaxCustFilter = NULL;	
			OpenFileStruct.nFilterIndex = 1;	
			OpenFileStruct.lpstrFile = szFileName;	
			OpenFileStruct.nMaxFile = 155;	
			OpenFileStruct.lpstrFileTitle = NULL;	
			OpenFileStruct.nMaxFileTitle = 0;	
			OpenFileStruct.lpstrInitialDir = NULL;	
			OpenFileStruct.lpstrTitle = NULL;	
			OpenFileStruct.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;	
			OpenFileStruct.nFileOffset = 0;	
			OpenFileStruct.nFileExtension = 1;	
			OpenFileStruct.lpstrDefExt = "msf";	
			OpenFileStruct.lCustData = 0;	
			OpenFileStruct.lpfnHook = NULL;	
			OpenFileStruct.lpTemplateName = NULL;	
			GetOpenFileName(&OpenFileStruct);
			if (str_len(szFileName))
			{
				fileHandle = file_open_read(szFileName);
				NewMaterial.ambient_red = file_var_read(fileHandle);
				NewMaterial.ambient_green = file_var_read(fileHandle);
				NewMaterial.ambient_blue = file_var_read(fileHandle);
				NewMaterial.emissive_red = file_var_read(fileHandle);
				NewMaterial.emissive_green = file_var_read(fileHandle);
				NewMaterial.emissive_blue = file_var_read(fileHandle);
				NewMaterial.diffuse_red = file_var_read(fileHandle);
				NewMaterial.diffuse_green = file_var_read(fileHandle);
				NewMaterial.diffuse_blue = file_var_read(fileHandle);
				NewMaterial.specular_red = file_var_read(fileHandle);
				NewMaterial.specular_green = file_var_read(fileHandle);
				NewMaterial.specular_blue = file_var_read(fileHandle);
				NewMaterial.power = file_var_read(fileHandle);
				NewMaterial.alpha = file_var_read(fileHandle);
				NewMaterial.sun_albedo = file_var_read(fileHandle);
				file_close(fileHandle);
			}
			break;
		case 3:
			memset((void*)&OpenFileStruct,0,sizeof(OPENFILENAME));	
			szFileName[0] = '\0';	
			OpenFileStruct.lStructSize = sizeof(OPENFILENAME);	
			OpenFileStruct.hwndOwner = hWnd;	
			OpenFileStruct.hInstance = NULL;	
			OpenFileStruct.lpstrFilter = "Source File\0*.c\0\0\0";	
			OpenFileStruct.lpstrCustomFilter = NULL;	
			OpenFileStruct.nMaxCustFilter = NULL;	
			OpenFileStruct.nFilterIndex = 1;	
			OpenFileStruct.lpstrFile = szFileName;	
			OpenFileStruct.nMaxFile = 155;	
			OpenFileStruct.lpstrFileTitle = NULL;	
			OpenFileStruct.nMaxFileTitle = 0;	
			OpenFileStruct.lpstrInitialDir = NULL;	
			OpenFileStruct.lpstrTitle = NULL;	
			OpenFileStruct.Flags = OFN_OVERWRITEPROMPT;	
			OpenFileStruct.nFileOffset = 0;	
			OpenFileStruct.nFileExtension = 1;	
			OpenFileStruct.lpstrDefExt = "c";	
			OpenFileStruct.lCustData = 0;	
			OpenFileStruct.lpfnHook = NULL;	
			OpenFileStruct.lpTemplateName = NULL;	
			GetSaveFileName(&OpenFileStruct);
			if (str_len(szFileName))
			{
				strOutput = str_create("");
				fileHandle = file_open_write(szFileName);
				str_cpy(strOutput,"MATERIAL* NewMaterial = \n{\n");
				file_str_write(fileHandle,strOutput);

				str_cpy(strOutput,"  	ambient_red = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.ambient_red);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	ambient_green = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.ambient_green);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	ambient_blue = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.ambient_blue);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	emissive_red = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.emissive_red);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	emissive_green = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.emissive_green);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	emissive_blue = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.emissive_blue);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	diffuse_red = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.diffuse_red);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	diffuse_green = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.diffuse_green);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	diffuse_blue = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.diffuse_blue);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	specular_red = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.specular_red);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	specular_green = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.specular_green);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	specular_blue = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.specular_blue);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	power = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.power);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	alpha = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.alpha);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"  	albedo = ");
				file_str_write(fileHandle,strOutput);
				file_var_write(fileHandle,(int)NewMaterial.sun_albedo);
				file_str_write(fileHandle,";\n");

				str_cpy(strOutput,"}\n\n");
				file_str_write(fileHandle,strOutput);
				file_close(fileHandle);
			}
			break;
	}
	wait(5);
	mouse_mode = 2;
	panel_editor_cover.flags &= ~VISIBLE;
	ClickBlock = 0;

}

//============================================================================
// save the settings 
void Btn1()
{
	if (ClickBlock == 0)
	{
		panel_editor_cover.flags |= VISIBLE;
		ClickBlock = 1;
		DoFileMenu(1);
	}
}

//============================================================================
// load the settings
void Btn2()
{
	if (ClickBlock == 0)
	{
		panel_editor_cover.flags |= VISIBLE;
		ClickBlock = 1;
		DoFileMenu(2);
	}
}

//============================================================================
// write the code
void Btn3()
{
	if (ClickBlock == 0)
	{
		panel_editor_cover.flags |= VISIBLE;
		ClickBlock = 1;
		DoFileMenu(3);
	}
}

//============================================================================
// load a model
void Btn4()
{
	if (ClickBlock == 0)
	{
		panel_editor_cover.flags |= VISIBLE;
		ClickBlock = 1;
		DoFileMenu(0);
	}
}

//============================================================================
// exit the program
void Btn5()
{
	if (ClickBlock == 0)
	{
		sys_exit("");
	}
}

//============================================================================
// setup the program and start the main loop that will ajust the mouse pointer
// and ajust the albedo and EditEntity flags for translucent and alpha value 
void main()
{
	wait(2);
	level_load("empty.wmb");
	video_switch(8,32,0);
	wait(2);
	panel_editor_cover.alpha = 25;
	vec_set(camera.x,vector(-200,0,0));
	vec_set(sky_color,vector(128,8,8)); 
	mouse_spot.x = 5;
	mouse_spot.y = 5;
	mouse_mode = 2; // show the pointer
	mouse_map = PTR_bmap;
	mouse_pointer = 1;
	on_mouse_left = MouseLeft;
	on_mouse_right = MouseRight;
	while (1) // as long as we haven't started the game
	{
		mouse_pos.x = mouse_cursor.x;
		mouse_pos.y = mouse_cursor.y;
		if (EditEntity != NULL)
		{
			EditEntity.alpha = NewMaterial.alpha;
			if (EditEntity.alpha < 99)
			{
				EditEntity.flags |= TRANSLUCENT;
			} 
			if (EditEntity.alpha >= 99)
			{
				EditEntity.flags &= ~TRANSLUCENT;
			}
		}
		NewMaterial.sun_albedo = MyAlbedo - 100;
		wait (1); 		      
	}
}
